#!/bin/bash
set +x
#Name           : Toshiba EloConfig Script
#Version        : 1.05
#Date modified  : 4/27/13
#Author         : fliwa@sg.ibm.com
#Modified script to run eloconfig by detaching and unloading  elousb drivers and
#then loading the elofousb driver and back to loading the elousb driver again.


ver=1.05
#elousb_used=false


# Make sure only root can run our script
if [[ $EUID -ne 0 ]]; then
   echo "This script must be run as root" 1>&2
   exit 1
fi
echo 
echo "Running Toshiba EloConfig script version $ver"

#after detaching the device , now we can unload it because its not talking to a device already.
#if elousb is loaded then remove it for awhile, we wont be using this
if lsmod | grep elousb > /dev/null
then
  #modprobe -r elousb
  echo -e 'elousb is not blacklisted yet'
  elousb_used=true
else
  echo -e 'elousb is blacklisted'
fi


#check if elofousb is active and remove for first run after boot
if lsmod | grep elofousb > /dev/null
then
  echo "The \"elofousb\" module will be removed!"
 modprobe -r elofousb
fi

#pause to let the os catch up with the remove and probe of elofousb
sleep 2

#loading the firmware update driver,elofousb
modprobe elofousb

#pause to let host catch up with the elofousb probing
sleep 2

#invoking the main elodownload executable from ELO
eloconfig $1 $2 $3 $4 $5
RC=$?


#pause to let the os catch up with the removal of elofousb
sleep 2

#now remove the elofousb driver, since we're done updating
modprobe -r elofousb
sleep 2


#if [ -s "/root/Desktop/modprobe.conf" ]
#then
#     echo 'found modprobe.conf ... moving it back to /etc/!'
#     rm -rf /etc/modprobe.conf
#     cp /root/Desktop/modprobe.conf /etc/modprobe.conf
#     modprobe elousb
#fi


sleep 2

#return the exit code from eloconfig
exit ${RC}


