#! /usr/bin/env python

'''
Module Name:    MUSConfigParser.py

Description:    This will performs parsing of the MUS configuration files.

Copyright:      Toshiba Confidential

                OCO Source Materials

                Copyright (C) 2012 Toshiba Global Commerce Solutions, Inc.

                The source code for this program is not published
                or otherwise divested of its trade secrets,
                irrespective of what has been deposited with the
                U. S. Copyright Office.

Initial Author: Francisco Liwa

Function:

Notes:

Dependencies:    None

Restrictions:    None

Created: October 3, 2012

'''

import ConfigParser
import os,sys

from monitorupgrade import TLog as TLOG

MUS_CONFIG_FILENAME= 'mus_conf.ini'

class MUSConfigParser(ConfigParser.ConfigParser):
    
    
    def __init__(self):
        '''
        Constructor
        '''
        #print'MUSConfigParser Constructed'
        TLOG.logger.info('MUSConfigParser Constructed')
        self.config = ConfigParser.ConfigParser();
        #super(MUSConfigParser,self).__init__(allow_no_value=True)
        
    def setOptionList(self):
        
        self.options_list = []
        
        for section in self.config.sections():                      
            for option in self.config.options(section):
                self.options_list.append(option)
                
    
    def getOptionList(self):
        return self.options_list
    
    def readConfig(self,config_file_path):
        self.config_file = os.path.abspath(config_file_path)
        if os.path.exists(config_file_path):
            self.config.read(self.config_file)
        else:
            print 'No Config file'
            TLOG.logger.info('MUSConfigParser::readConfig()-No Config file ')
            sys.exit()
        self.setOptionList()
        
    def ConfigSectionMap(self,section):
        dict1 = {}
        options = self.config.options(section)
        for option in options:
            try:
                dict1[option] = self.config.get(section, option)
                if dict1[option] == -1:
                    print("skip: %s" % option)
            except:
                print("exception on %s!" % option)
                dict1[option] = None
        return dict1       
    
    def dump(self):
        
        for section in self.config.sections():
            print section
            
            for option in self.config.options(section):
                print " ", option,"=",self.config.get(section,option)
                
                    
        