#! /usr/bin/env python

'''
Module Name:    app_main.py

Description:   This is the main App to be called by the Init Script MonitorUpgradeSvc.py

Copyright:      Toshiba Confidential

                OCO Source Materials

                Copyright (C) 2012 Toshiba Global Commerce Solutions, Inc.

                The source code for this program is not published
                or otherwise divested of its trade secrets,
                irrespective of what has been deposited with the
                U. S. Copyright Office.

Initial Author: Francisco Liwa

Function:

Notes:

Dependencies:    None

Restrictions:    None

Created: October 3, 2012

'''


MUS_DIR = '/opt/toshiba/MonitorUpgrade/mus/scripts'


import sys
import subprocess
sys.path.append(MUS_DIR) 

from monitorupgrade import TaskMgr
from monitorupgrade import TLog as TLOG




#==========================================================================================================
# Class App - Wrapper class to our TaskManager
#==========================================================================================================
class App:
    
    def __init__(self):
        print'App Constructed!'
        TLOG.logger.info('App Constructed!')
     
    def run(self):
        print'App::run-Starting MUS App'
        TLOG.logger.info('App::run()-START')
        
        TLOG.logger.info('App::run()-Creating TaskManager Object')
        _tskmgr = TaskMgr.TaskMgr()
        
        TLOG.logger.info('App::run()-Calling TaskMgr::initialize() ')
        _tskmgr.initialize()
        
        TLOG.logger.info('App::run()-Calling TaskMgr::performTasks()')
        stat = _tskmgr.performTasks()
        
        reboot = _tskmgr.getRebootFlag()
        #call clean-up here
  
        TaskMgr.cleanUp(_tskmgr.RECOVERY_MODE)
        
        print'App::run()-END'
        TLOG.logger.info('App::run()-END')
          
        if ( reboot ) :
            print 'rebooting now..'
            proc = subprocess.call('reboot',shell=True)
      
        return stat
    
    
    
    
    